<?php

class HelperAppUnixServerSocket
{
	var $sock;
	
	function HelperAppUnixServerSocket( $path )
	{
		$this->sock = socket_create( AF_UNIX, SOCK_STREAM, 0 );

		if ( !$this->sock )
			die( "Couldn't create socket: " . socket_strerror( socket_last_error() ) );

		if ( !socket_connect( $this->sock, $path) )
			die( "Couldn't connect socket to $path: " . socket_strerror( socket_last_error() ) );
	}
	
	function close()
	{
		socket_close( $this->sock );
	}
	
	function read()
	{
		$msg_len_str = $this->readBytes( 4 );

		if ( !$msg_len_str )
			return NULL;

		$msg_len_unpack = unpack( 'Nlen', $msg_len_str );
		$msg_len        = $msg_len_unpack['len'];
		$msg            = $this->readBytes( $msg_len );

		return $msg;
	}

	function write( $data )
	{
		$msg_len = strlen( $data );

		$this->writeBytes( pack( 'N', $msg_len ) );
		$this->writeBytes( $data );
	}

	function readBytes( $numBytes )
	{
		$in     = '';
		$amt_in = 0;

		while ( $amt_in < $numBytes ) {
			$one_in = socket_read( $this->sock, $numBytes - $amt_in );

			if ( $one_in === FALSE || $one_in == '' )
				return NULL;

			$in     .= $one_in;
			$amt_in += strlen( $one_in );
		}

		return $in;
	}

	function writeBytes( $bytes )
	{
		$len     = strlen( $bytes );
		$amt_out = 0;

		while ( $amt_out < $len ) {
			$one_out = socket_write( $this->sock, substr( $bytes, $amt_out ) );

			if ( $one_out === FALSE )
				return FALSE;

			$amt_out += $one_out;
		}

		return TRUE;
	}
}

?>